#include <Stepper.h>
#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#define OLED_RESET 4 
Adafruit_SSD1306 display(OLED_RESET);
const int stepsPerRevolution = 200;
Stepper myStepper(stepsPerRevolution, 9, 18, 19, 20);
#if (SSD1306_LCDHEIGHT != 32) 
#error("Height incorrect, please fix Adafruit_SSD1306.h!");
#endif
void setup() { 
Serial.begin(9600);
Serial.setTimeout(200);
display.begin(SSD1306_SWITCHCAPVCC, 0x3C); // initialize with the I2C addr 0x3D (for the 128x64)
display.display();
display.setTextSize(1); 
display.setTextColor(WHITE); 
display.setCursor(10, 0); 
display.clearDisplay(); 
  myStepper.setSpeed(180);
  myStepper.step(-600);
  digitalWrite(9,LOW);
  digitalWrite(18,LOW);
  digitalWrite(19,LOW);
  digitalWrite(20,LOW);
  //delay(300);
  myStepper.setSpeed(180);
  myStepper.step(-600);
  digitalWrite(9,LOW);
  digitalWrite(18,LOW);
  digitalWrite(19,LOW);
  digitalWrite(20,LOW);

}
void loop() { 
while (1) { 
display.setTextColor(WHITE); 

printText();

}
}
void printText(void) { 
String s;
String cpu;
String tme;
if (Serial.available()) { 
  display.fillCircle(4, 4, 3, WHITE);
  display.display();
  //s1 = Serial.readString();
  s = Serial.readString(); //getting string input in variable "s" 
  cpu=s;
  tme=s;
  Serial.println(s);
  //Serial.println("Ok");
  if(s[0]=='d'){
    display.clearDisplay();
    display.setCursor(1, 1);
    display.setTextSize(2);
    display.println("Going Down!");
    display.display();
    myStepper.setSpeed(100);
    myStepper.step(stepsPerRevolution);
    digitalWrite(9,LOW);
    digitalWrite(18,LOW);
    digitalWrite(19,LOW);
    digitalWrite(20,LOW);
    display.clearDisplay();
    display.setCursor(1, 1);
    display.setTextSize(2);
    display.println("Done!");
    display.display();
  }
  else if(s[0]=='u'){
    display.clearDisplay();
    display.setCursor(1, 1);
    display.setTextSize(2);
    display.println("Going Up!");
    display.display();
    myStepper.setSpeed(100);
    myStepper.step(-stepsPerRevolution);
    digitalWrite(9,LOW);
    digitalWrite(18,LOW);
    digitalWrite(19,LOW);
    digitalWrite(20,LOW);
    display.clearDisplay();
    display.setCursor(1, 1);
    display.setTextSize(2);
    display.println("Done!");
    display.display();
    }
    else if(s[0]=='h'){
    display.clearDisplay();
    display.setCursor(10, 1);
    display.setTextSize(2);
    display.println("Hello!");
    display.display();
    myStepper.setSpeed(180);
    myStepper.step(-1200);
    digitalWrite(9,LOW);
    digitalWrite(18,LOW);
    digitalWrite(19,LOW);
    digitalWrite(20,LOW);
    }

    else if(s[0]=='b'){
    display.clearDisplay();
    display.setCursor(1, 1);
    display.setTextSize(2);
    display.println("Bye!");
    display.display();
    myStepper.setSpeed(180);
    myStepper.step(1200);
    digitalWrite(9,LOW);
    digitalWrite(18,LOW);
    digitalWrite(19,LOW);
    digitalWrite(20,LOW);
    display.clearDisplay();
    display.display();
    }

  else if(s[0]=='t'){  
      //Serial.println("s[0]=t");
      for (int i=0;i<s.length();i++){
        if(s[i]=='c'){
        cpu.remove(0,1+i);
        tme.remove(i,s.length());
        tme.remove(0,1);
        display.clearDisplay();
        display.setCursor(1, 10);
        display.setTextSize(3.5);
        display.println("CPU"+cpu+"%");
        display.setCursor(30, 0);
        display.setTextSize(1.8);
        display.println(tme);
        display.display();
      }
    }
  }
  else {
        //Serial.println("else");
        display.clearDisplay();
        display.setCursor(1, 1);
        display.setTextSize(3.5);
        display.println("Error!");
        display.display();
    }


}
}
